import {
  Body,
  Controller,
  Delete,
  Get,
  Patch,
  Path,
  Post,
  Request,
  Route,
  Security,
  Tags,
} from "tsoa";
import { AppDataSource } from "../database/data-source";
import {
  CreateProfileAssistanceEmployee,
  ProfileAssistance,
  UpdateProfileAssistance,
} from "../entities/ProfileAssistance";
import { ProfileAssistanceHistory } from "../entities/ProfileAssistanceHistory";
import { RequestWithUser } from "../middlewares/user";
import HttpError from "../interfaces/http-error";
import HttpStatus from "../interfaces/http-status";
import HttpSuccess from "../interfaces/http-success";
import { ProfileEmployee } from "../entities/ProfileEmployee";
import permission from "../interfaces/permission";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile-temp/assistance")
@Tags("ProfileAssistanceEmployee")
@Security("bearerAuth")
export class ProfileAssistanceEmployeeTempController extends Controller {
  private profileEmployeeRepo = AppDataSource.getRepository(ProfileEmployee);
  private profileAssistanceRepo = AppDataSource.getRepository(ProfileAssistance);
  private profileAssistanceHistoryRepo = AppDataSource.getRepository(ProfileAssistanceHistory);

  @Get("user")
  public async detailProfileAssistanceUser(@Request() request: { user: Record<string, any> }) {
    const profile = await this.profileEmployeeRepo.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const getProfileAssistanceId = await this.profileAssistanceRepo.find({
      where: { profileEmployeeId: profile.id, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    if (!getProfileAssistanceId) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(getProfileAssistanceId);
  }

  @Get("{profileEmployeeId}")
  public async detailProfileAssistance(
    @Path() profileEmployeeId: string,
    @Request() req: RequestWithUser,
  ) {
    let _workflow = await new permission().Workflow(req, profileEmployeeId, "SYS_REGISTRY_TEMP");
    if (_workflow == false) await new permission().PermissionGet(req, "SYS_REGISTRY_TEMP");
    const getProfileAssistanceId = await this.profileAssistanceRepo.find({
      where: { profileEmployeeId: profileEmployeeId, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    if (!getProfileAssistanceId) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(getProfileAssistanceId);
  }

  @Get("admin/history/{assistanceId}")
  public async getProfileAdminAssistanceHistory(
    @Path() assistanceId: string,
    @Request() req: RequestWithUser,
  ) {
    const _record = await this.profileAssistanceRepo.findOneBy({ id: assistanceId });
    if (_record) {
      let _workflow = await new permission().Workflow(req, assistanceId, "SYS_REGISTRY_TEMP");
      if (_workflow == false) await new permission().PermissionGet(req, "SYS_REGISTRY_TEMP");
    }
    const record = await this.profileAssistanceHistoryRepo.find({
      where: { profileAssistanceId: assistanceId },
      order: { createdAt: "DESC" },
    });
    if (!record) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(record);
  }

  @Get("history/{assistanceId}")
  public async getProfileAssistanceHistory(@Path() assistanceId: string) {
    const record = await this.profileAssistanceHistoryRepo.find({
      where: { profileAssistanceId: assistanceId },
      order: { createdAt: "DESC" },
    });
    if (!record) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(record);
  }

  @Post()
  public async newProfileAssistance(
    @Request() req: RequestWithUser,
    @Body() body: CreateProfileAssistanceEmployee,
  ) {
    if (!body.profileEmployeeId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileEmployeeId");
    }

    const profile = await this.profileEmployeeRepo.findOneBy({ id: body.profileEmployeeId });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    await new permission().PermissionUpdate(req, "SYS_REGISTRY_TEMP");
    const before = null;
    const data = new ProfileAssistance();
    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    const history = new ProfileAssistanceHistory();
    Object.assign(history, { ...data, id: undefined });

    await this.profileAssistanceRepo.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileAssistanceId = data.id;
    await this.profileAssistanceHistoryRepo.save(history, { data: req });
    //setLogDataDiff(req, { before, after: history });

    return new HttpSuccess(data.id);
  }

  @Patch("{assistanceId}")
  public async editProfileAssistance(
    @Body() body: UpdateProfileAssistance,
    @Request() req: RequestWithUser,
    @Path() assistanceId: string,
  ) {
    const record = await this.profileAssistanceRepo.findOneBy({ id: assistanceId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    await new permission().PermissionUpdate(req, "SYS_REGISTRY_TEMP");
    const before = structuredClone(record);
    // const before_null = null;
    const history = new ProfileAssistanceHistory();

    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    history.profileAssistanceId = assistanceId;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    this.profileAssistanceRepo.save(record, { data: req });
    setLogDataDiff(req, { before, after: record });
    if (!(Object.keys(body).length === 1 && body.isUpload)) {
      this.profileAssistanceHistoryRepo.save(history, { data: req });
      // setLogDataDiff(req, { before, after: history });
    }

    return new HttpSuccess();
  }

  /**
   * API ลบข้อมูลช่วยราชการ
   * @summary API ลบข้อมูลช่วยราชการ
   * @param assistanceId คีย์ช่วยราชการ
   */
  @Patch("update-delete/{assistanceId}")
  public async updateIsDeleted(
    @Request() req: RequestWithUser,
    @Path() assistanceId: string,
  ) {
    const record = await this.profileAssistanceRepo.findOneBy({ id: assistanceId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    if (record.isDeleted === true) {
      return new HttpSuccess();
    }
    await new permission().PermissionDelete(req, "SYS_REGISTRY_TEMP");
    const before = structuredClone(record);
    const history = new ProfileAssistanceHistory();
    const now = new Date();
    record.isDeleted = true;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = now;

    Object.assign(history, { ...record, id: undefined });
    history.profileAssistanceId = assistanceId;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = now;

    await Promise.all([
      this.profileAssistanceRepo.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.profileAssistanceHistoryRepo.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{assistanceId}")
  public async deleteProfileAssistance(
    @Path() assistanceId: string,
    @Request() req: RequestWithUser,
  ) {
    const _record = await this.profileAssistanceRepo.findOneBy({ id: assistanceId });
    if (_record) {
      await new permission().PermissionDelete(req, "SYS_REGISTRY_TEMP");
    }

    await this.profileAssistanceHistoryRepo.delete({
      profileAssistanceId: assistanceId,
    });

    const result = await this.profileAssistanceRepo.delete({ id: assistanceId });

    if (result.affected == undefined || result.affected <= 0) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess();
  }
}
